
/*
 *  Copyright (C) 1992-1993 Jeffrey Chilton
 *
 *  Permission is granted to anyone to make or distribute copies of
 *  this program, in any medium, provided that the copyright notice
 *  and permission notice are preserved, and that the distributor
 *  grants the recipient permission for further redistribution as
 *  permitted by this notice.
 *  
 *  Author's E-mail address:  172-9221@mcimail.com
 *  
 */

/* static char *whatstring = "@(#)form.h	2.4 JWC"; */

#ifndef FORM_H
#define FORM_H

/*
 *  Form - General lingusitic form description
 */

typedef struct Form Form;

#define PERSON_FIRST 0
#define PERSON_SECOND 1
#define PERSON_THIRD 2
#define N_OF_PERSON 3

#define PLURAL_SINGULAR 0
#define PLURAL_PLURAL 1
#define N_OF_PLURAL 2

#define GENDER_MALE 0
#define GENDER_FEMALE 1
#define N_OF_GENDER 2

#define IMPERSUM(s, l) (l + s * 2 - 1)

struct Form
{
    int person;
    int plurality;
    int gender;
};

#if __STDC__

extern Form *Form_new(int person, int plurality, int gender);
extern Form *Form_newFromImage(char *image);
extern int Form_isEquivalent(Form *self, Form *x);
extern char *Form_image(Form *self);
extern void Form_destroy(Form *self);

#else

extern Form *Form_new();
extern Form *Form_newFromImage();
extern int Form_isEquivalent();
extern char *Form_image();
extern void Form_destroy();

#endif

#endif

